-- #include "../TAT/library.lua"
#include "../2414735699/library.lua"


--[[ 08-15-2022 (mm-dd-yyyy) version 0.8.0]]---


function init()
	matchList = {}
	rejectList = {}
	coupledVehicles = {}

	initVehicles = {}
	initCouplers = FindShapes("Tcoupler", true)
	initPlugs = FindShapes("Twire", true)
	initLegs = FindBodies("Tleg", true)
	playerVehicle = 0
	ctrlTrailer = 0

	interKey = "T"
	operation = "Return"
	trailerOperation = "Shift"
	viewCondition = "Alt"
	trailerDyna = "Backspace"
	VCnext = "PgDown"
	VCpre = "PgUp"
	VCstatus = true
	VCpage = 1
	useDyna = false

	debug = false

	for i=1, #initCouplers do
		SetTag(initCouplers[i], "nocull")
		SetTag(initCouplers[i], "unbreakable")
		local couplerVehicle = GetBodyVehicle(GetShapeBody(initCouplers[i]))
		local existed = false
		for v=1, #initVehicles do
			if initVehicles[v] == couplerVehicle then
				existed = true
			end
		end
		if not existed then
			table.insert(initVehicles, couplerVehicle)
		end
	end

	for i=1, #initPlugs do
		SetTag(initPlugs[i], "nocull")
		SetTag(initPlugs[i], "unbreakable")
	end

	for i=1, #initLegs do
		SetTag(initLegs[i], "nocull")
		SetTag(initLegs[i], "unbreakable")
		SetTag(initLegs[i], "Tactive")
		SetBodyActive(initLegs[i], true)
	end

	for i=1, #initVehicles do
		SetTag(initVehicles[i], "TAT", "ready")
		table.insert(matchList, {})

		local couplerList = {}
		local shapeCount = #initCouplers
		repeat
			if GetBodyVehicle(GetShapeBody(initCouplers[shapeCount])) == initVehicles[i] then
				table.insert(couplerList, {initCouplers[shapeCount], 0, false})
				table.remove(initCouplers, shapeCount)
			end
			shapeCount = shapeCount - 1
		until (shapeCount <= 0)

		local plugList = {}
		local wireCount = #initPlugs
		repeat
			if GetBodyVehicle(GetShapeBody(initPlugs[wireCount])) == initVehicles[i] then
				table.insert(plugList, initPlugs[wireCount])
				table.remove(initPlugs, wireCount)
			end
			wireCount = wireCount - 1
		until (wireCount <= 0)

		local legList = {}
		local legCount = #initLegs
		repeat
			if GetBodyVehicle(initLegs[legCount]) == initVehicles[i] then
				table.insert(legList, initLegs[legCount])
				table.remove(initLegs, legCount)
			end
			legCount = legCount - 1
		until (legCount <= 0)

		rawset(matchList, #matchList, {vehicle = initVehicles[i], coupler = couplerList, plug = plugList, leg = legList, status = false})
	end
end

function update(dt)

	for i=1, #matchList do
		local matchVehicle = matchList[i].vehicle
		local matchCoupler = matchList[i].coupler
		local matchStatus = matchList[i].status

		for m=1, #matchCoupler do
			local couplerShape = matchCoupler[m][1]
			local anotherShape = matchCoupler[m][2]
			local couplerReady = matchCoupler[m][3]

			if anotherShape ~= 0 and not couplerReady then
				local posA = ShapePosOffset(couplerShape)
				local posB = ShapePosOffset(anotherShape)
				local bodyA = GetShapeBody(couplerShape)
				local bodyB = GetShapeBody(anotherShape)
				ConstrainPosition(bodyA, bodyB, posA, posB)
				if VecLength(VecSub(posA, posB)) < 0.01 then
					matchList[i].coupler[m][3] = true
				end
			end
		end
	end
end

function tick(dt)

	tickCouplers = FindShapes("Tcoupler", true)
	playerVehicle = GetPlayerVehicle()
	coupledVehicles = {}

	for t=1, #tickCouplers do
		local couplerVehicle = GetBodyVehicle(GetShapeBody(tickCouplers[t]))
		local existed = false
		for v=1, #initVehicles do
			if initVehicles[v] == couplerVehicle then
				existed = true
			end
		end
		if not existed then
			SetTag(tickCouplers[t], "nocull")
			SetTag(tickCouplers[t], "unbreakable")
			table.insert(initVehicles, couplerVehicle)
			
			SetTag(couplerVehicle, "TAT", "ready")
			table.insert(matchList, {})
			local tickPlugs = FindShapes("Twire", true)
			local tickLegs = FindBodies("Tleg", true)

			local couplerList = {}
			local shapeCount = #tickCouplers
			repeat
				if GetBodyVehicle(GetShapeBody(tickCouplers[shapeCount])) == couplerVehicle then
					table.insert(couplerList, {tickCouplers[shapeCount], 0, false})
					table.remove(tickCouplers, shapeCount)
				end
				shapeCount = shapeCount - 1
			until (shapeCount <= 0)

			local plugList = {}
			local wireCount = #tickPlugs
			repeat
				SetTag(tickPlugs[wireCount], "nocull")
				SetTag(tickPlugs[wireCount], "unbreakable")
				if GetBodyVehicle(GetShapeBody(tickPlugs[wireCount])) == couplerVehicle then
					table.insert(plugList, tickPlugs[wireCount])
					table.remove(tickPlugs, wireCount)
				end
				wireCount = wireCount - 1
			until (wireCount <= 0)

			local legList = {}
			local legCount = #tickLegs
			repeat
				SetTag(tickLegs[legCount], "nocull")
				SetTag(tickLegs[legCount], "unbreakable")
				SetTag(tickLegs[legCount], "Tactive")
				SetBodyActive(tickLegs[legCount], true)
				if GetBodyVehicle(tickLegs[legCount]) == couplerVehicle then
					table.insert(legList, tickLegs[legCount])
					table.remove(tickLegs, legCount)
				end
				legCount = legCount - 1
			until (legCount <= 0)

			rawset(matchList, #matchList, {vehicle = couplerVehicle, coupler = couplerList, plug = plugList, leg = legList, status = false})
		end
	end

	for i=1, #matchList do
		local matchVehicle = matchList[i].vehicle
		local matchCoupler = matchList[i].coupler
		local matchStatus = matchList[i].status
		local matchPlug = matchList[i].plug
		local matchLeg = matchList[i].leg
		
		local connected = false

		local steerFollowVehicle = 0

		for m=1, #matchCoupler do
			local couplerShape = matchCoupler[m][1]
			local anotherShape = matchCoupler[m][2]
			local couplerReady = matchCoupler[m][3]
			local anotherVehicle = GetBodyVehicle(GetShapeBody(anotherShape))
			local coupledBodies = GetJointedBodies(GetShapeBody(couplerShape))
			local anotherPlug = {}

			if GetTagValue(couplerShape, "Tcoupler") == "passive" then
				if steerFollowVehicle == 0 then
					steerFollowVehicle = anotherVehicle
				elseif steerFollowVehicle > 0 then
					steerFollowVehicle = -1
				end
			end

			if debug then
				if anotherShape ~= 0 then
					DebugCross(ShapePosOffset(couplerShape), 0, 1, 0, 1)
				else
					if couplerReady then
						DebugCross(ShapePosOffset(couplerShape), 0, 0, 1, 1)
					else
						DebugCross(ShapePosOffset(couplerShape))
					end
				end
			end

			if anotherShape ~= 0 then
				SetShapeCollisionFilter(couplerShape, 2, 255-2)
				SetShapeCollisionFilter(anotherShape, 2, 255-2)
			end

			ControlLegs((anotherShape ~= 0), matchLeg, tonumber(GetTagValue(couplerShape, "Tgroup")))

			for cpb=1, #coupledBodies do
				local checkingVehicle = GetBodyVehicle(coupledBodies[cpb])
				if checkingVehicle == playerVehicle and matchVehicle ~= playerVehicle then
					connected = true
					break
				end
			end

			if matchStatus then
				if GetTagValue(couplerShape, "Tcoupler") ~= "passive" then
					if anotherShape == 0 then
	
						local shapePos = ShapePosOffset(couplerShape)
						local hit, point, normal, shape
						matchList[i].coupler[m][3] = false
	
						repeat
							QueryRequire("physical dynamic large")
							QueryRejectVehicle(matchVehicle)
							for rej=1, #rejectList do
								QueryRejectShape(rejectList[rej])
							end
							hit, point, normal, shape = QueryClosestPoint(shapePos, 0.5)
	
							if hit then
								if not HasTag(shape, "Tcoupler") then
									table.insert(rejectList, shape)
								else
									matchList[i].coupler[m][2] = shape
									SetTag(shape, "Ttemp", couplerShape)
								end
							end
						until (not hit or HasTag(shape, "Tcoupler"))
	
						if not hit then
							matchStatus = false
							matchList[i].status = matchStatus
							matchList[i].coupler[m][2] = 0
							matchList[i].coupler[m][3] = false
						end
					else
						if couplerReady then
							local couplerJoints = GetShapeJoints(couplerShape)
							local couplerDone = false
							local couplerGroup = tonumber(GetTagValue(couplerShape, "Tgroup")) or 0
							local anotherGroup = tonumber(GetTagValue(anotherShape, "Tgroup")) or 0
	
							for j=1, #couplerJoints do
								if HasTag(couplerJoints[j], "T"..couplerShape) then
									couplerDone = true
								end
							end
	
							if not couplerDone then
								local tagStr = "T"..couplerShape.." T"..anotherShape
								Spawn('<joint tags="'..tagStr..'"/>', Transform(ShapePosOffset(couplerShape)), true, true)
	
								for k=1, #matchList do
									if matchList[k].vehicle == anotherVehicle then
										anotherPlug = matchList[k].plug
									end
								end
	
								for p=1, #matchPlug do
									for q=1, #anotherPlug do
										if GetTagValue(anotherPlug[q], "Twire") == GetTagValue(matchPlug[p], "Twire") then
											local groupA = tonumber(GetTagValue(matchPlug[p], "Tgroup")) == couplerGroup
											local groupB = tonumber(GetTagValue(anotherPlug[q], "Tgroup")) == anotherGroup
											if groupA and groupB then
												local startPos = GetShapeCenter(anotherPlug[q])
												local endPos = GetShapeCenter(matchPlug[p])
												local HEXcolor = string.upper(GetTagValue(matchPlug[p], "Tcolor"))
												
												local wireColor = ""
												if HEXcolor ~= "" then
													wireColor = HEXtoRGB(HEXcolor)
												end
												
												local wireStr = '\
													<rope slack="0.1" tags="'..tagStr..'" color="'..wireColor..'">\
														<location pos="'..table.concat(startPos, " ")..'"/>\
														<location pos="'..table.concat(endPos, " ")..'"/>\
													</rope>'
												Spawn(wireStr, Transform(Vec(0, 0, 0)), true, true)
												break
											end
										end
									end
								end
							end
						end
					end
				end
			else
				if couplerShape and GetTagValue(couplerShape, "Tcoupler") ~= "passive" then
					SetTag(anotherShape, "Ttemp")
					matchList[i].coupler[m][2] = 0
					matchList[i].coupler[m][3] = false
					local couplerJoints = FindJoints("T"..couplerShape, true)
					for j=1, #couplerJoints do
						Delete(couplerJoints[j])
					end
				end
			end

			if HasTag(couplerShape, "Ttemp") then
				matchList[i].coupler[m][2] = tonumber(GetTagValue(couplerShape, "Ttemp")) or 0
				RemoveTag(couplerShape, "Ttemp")
			end
		end

		if connected then
			SetTag(matchVehicle, "TAT", GetPlayerVehicle())
		else
			SetTag(matchVehicle, "TAT", 0)
		end

		if playerVehicle == matchVehicle then
			if InputPressed(operation) and not HasTag(matchVehicle, "nodrive") then
				matchStatus = not matchStatus
				matchList[i].status = matchStatus
			end
		else
			if playerVehicle ~= 0 then
				if connected then
					DriveTrailer(matchVehicle, playerVehicle, steerFollowVehicle)
					table.insert(coupledVehicles, matchVehicle)

					if InputPressed("shift") and matchVehicle == ctrlTrailer then
						matchStatus = not matchStatus
						matchList[i].status = matchStatus
					end
				end
			end
		end
	end
end

function draw(dt)

	if HasTag(playerVehicle, "TAT") and (not GetBool("YLVF.pack.menu") and not GetBool("YLVF.pack.sub")) then

		infoA = {}
		infoB = {}
		truck = 0
		W1 = 0
		W2 = 0

		if InputPressed(string.lower(viewCondition)) and #coupledVehicles > 0 then VCstatus = not VCstatus end

		if InputPressed(string.lower(VCnext)) then
			VCpage = VCpage + 1
			if VCpage > #coupledVehicles then VCpage = 1 end
		end
		if InputPressed(string.lower(VCpre)) then
			VCpage = VCpage - 1
			if VCpage < 1 then VCpage = #coupledVehicles end
		end

		VCpage = math.max(1, math.min(VCpage, #coupledVehicles))

		local selectTrailer = coupledVehicles[VCpage]
		local trailerHealth = GetVehicleHealth(selectTrailer)

		if InputPressed(string.lower(trailerDyna)) and VCstatus then
			useDyna = not useDyna
		end

		if useDyna then
			SetTag(selectTrailer, "Tctrl")
		else
			RemoveTag(selectTrailer, "Tctrl")
		end

		infoA[#infoA+1] = {ReturnToEnter(operation), "Self"}
		infoA[#infoA+1] = {ReturnToEnter(viewCondition), "Trailer Info"}

		infoB[#infoB+1] = {ReturnToEnter(trailerOperation), "Trailer"}
		infoB[#infoB+1] = {ReturnToEnter(trailerDyna), "Toggle Dynamic Control"}
		infoB[#infoB+1] = {ReturnToEnter(VCpre), "Previous"}
		infoB[#infoB+1] = {ReturnToEnter(VCnext), "Next"}

		local W1, W2 = 0, 0
		local W1p, W2p = 0, 0

		for i=1, #infoA do
			UiFont("bold.ttf", 22)
			local width1 = UiGetTextSize(infoA[i][1])
			UiFont("regular.ttf", 22)
			local width2 = UiGetTextSize(infoA[i][2])
			W1 = math.max(W1,width1)
			W2 = math.max(W2,width2)
		end

		local prevW = math.max(W1 + W2 + 80, 300)
		local W1p, W2p = W1, W2

		if VCstatus then
			for i=1, #infoB do
				UiFont("bold.ttf", 22)
				local width1 = UiGetTextSize(infoB[i][1])
				UiFont("regular.ttf", 22)
				local width2 = UiGetTextSize(infoB[i][2])
				W1 = math.max(W1,width1)
				W2 = math.max(W2,width2)
			end
		end

		local infoW = math.max(W1 + W2 + 80, 300)
		local infoAH = #infoA*22 + 58
		local infoBH = #infoB*22 + 90

		if (not VCstatus) or (#coupledVehicles == 0) then
			infoBH = 0
			infoW = prevW
			W1 = W1p
			W2 = W2p
		end

		UiPush()
			UiAlign("top left")
			UiTranslate(20, UiHeight()-infoAH-infoBH-20)
			UiColor(0, 0, 0, 0.4)
			UiImageBox("ui/common/box-solid-6.png", infoW, infoAH+infoBH, 6, 6)
			UiTranslate(infoW/2, 32)
		
			UiPush()
				UiColor(1, 1, 1)
				UiFont("bold.ttf", 26)
				UiAlign("center")
				UiText("Connection Operation")
				UiTranslate((W1-W2)/2, 30)

				UiPush()
					for i=1, #infoA do
						UiFont("bold.ttf", 22)
						UiAlign("right")
						UiText(infoA[i][1])
						UiTranslate(10, 0)
						UiFont("regular.ttf", 22)
						UiAlign("left")
						UiText(infoA[i][2])
						UiTranslate(-10, 22)
					end
				UiPop()

				if VCstatus and selectTrailer then
					if not useDyna then
						local trailerBodies = GetJointedBodies(GetVehicleBody(selectTrailer))
						for t=1, #trailerBodies do
							if GetBodyVehicle(trailerBodies[t]) == selectTrailer then
								DrawBodyOutline(trailerBodies[t], 0.4)
							end
						end
					end
					ctrlTrailer = selectTrailer

					UiTranslate(0, infoAH-40)
		
					UiPush()
						for i=1, #infoB do
							UiFont("bold.ttf", 22)
							UiAlign("right")
							UiText(infoB[i][1])
							UiTranslate(10, 0)
							UiFont("regular.ttf", 22)
							UiAlign("left")
							UiText(infoB[i][2])
							UiTranslate(-10, 22)
						end
					UiPop()

					UiTranslate((W2-W1)/2, infoBH-62)
	
					UiPush()
						UiAlign("center middle")
							UiPush()
								UiTranslate(-126, 0)
								local thRGB = trailerHealth
								progressBar(200, 20, trailerHealth, {1-0.5*thRGB, 1*thRGB, (thRGB^2-thRGB)*2+0.2, 1})
								UiTranslate(232, 10)
								UiColor(1, 1, 1, 1)
								UiFont("Fonts/CrystalItalic-R6A.ttf", 20)
								UiText(math.floor(trailerHealth*100).."%")
							UiPop()
							UiPush()
								UiFont("bold.ttf", 20)
								UiColor(1, 1, 1)
								UiTranslate(0, -18)
								UiText("TRAILER CONDITION")
							UiPop()
						UiPop()
					UiPop()
				else
					ctrlTrailer = 0
				end
		UiPop()
	end

	if playerVehicle == 0 then
		for i=1, #matchList do
			local matchVehicle = matchList[i].vehicle
			local matchCoupler = matchList[i].coupler
			local matchStatus = matchList[i].status

			for m=1, #matchCoupler do
				local couplerShape = matchCoupler[m][1]
				local anotherShape = matchCoupler[m][2]
				local couplerReady = matchCoupler[m][3]
				local newShape = GetPlayerPickShape()
				if newShape == couplerShape and GetTagValue(couplerShape, "Tcoupler") ~= "passive" then
					if true then
						DrawShapeOutline(newShape, 1, 1, 1, 0.4)
					end
					if InputPressed(interKey) then
						matchStatus = not matchStatus
						matchList[i].status = matchStatus
					end
					UiPush()
						UiFont("bold.ttf", 22)
						local str = string.upper(ReturnToEnter(interKey)).." to "
						if matchStatus then
							str = str.."Disconnect"
						else
							str = str.."Connect"
						end
						local w = 16 + UiGetTextSize(str)
						UiAlign("center middle")
						UiTranslate(UiCenter(), UiMiddle()+400)
						UiColor(0.8, 1, 1, 0.6)
						UiImageBox("ui/common/box-solid-6.png", w, 34, 6, 6)
						UiColor(0, 0, 0)
						UiText(str)
					UiPop()
				end
			end
		end
	end
end


